diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index 1cdc6fd7b..3acee0969 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -49,15 +49,13 @@ import org.slf4j.Logger;
 
 import java.util.function.Function;
 
-public class PlayerLocal extends Player
-{
+public class PlayerLocal extends Player {
     private static final Logger LOGGER = LogUtils.getLogger();
     public PlayerInput input;
     protected Minecraft mc;
     protected int sprintTimer;
 
-    public PlayerLocal(Minecraft minecraft, World world, Session session, int dimension)
-    {
+    public PlayerLocal(Minecraft minecraft, World world, Session session, int dimension) {
         super(world);
         this.mc = minecraft;
         this.dimension = dimension;
@@ -84,18 +82,16 @@ public class PlayerLocal extends Player
         return f;
     }
 
-    public @Nullable AABBdc getCollisionAABB()
-    {
+    public @Nullable AABBdc getCollisionAABB() {
         if (this.noPhysics) {
             return null;
         } else {
             return super.getCollisionAABB();
         }
     }
-    
+
     @Override
-    public void updateAI()
-    {
+    public void updateAI() {
         super.updateAI();
         this.moveStrafing = this.input.moveStrafe;
         this.moveForward = this.input.moveForward;
@@ -103,18 +99,15 @@ public class PlayerLocal extends Player
     }
 
     @Override
-    public void setGamemode(Gamemode gamemode)
-    {
+    public void setGamemode(Gamemode gamemode) {
         this.gamemode = gamemode;
 
         MenuInventory newContainer = gamemode.getContainer(this.inventory, !this.world.isClientSide);
-        if (this.craftingInventory == this.inventorySlots)
-        {
+        if (this.craftingInventory == this.inventorySlots) {
             this.craftingInventory = newContainer;
         }
         this.inventorySlots = newContainer;
-        if (!gamemode.canPlayerFly())
-        {
+        if (!gamemode.canPlayerFly()) {
             this.noPhysics = false;
         }
 
@@ -122,77 +115,61 @@ public class PlayerLocal extends Player
     }
 
     @Override
-    public void onLivingUpdate()
-    {
-        if (this.sprintTimer > 0)
-        {
+    public void onLivingUpdate() {
+        if (this.sprintTimer > 0) {
             this.sprintTimer--;
         }
 
         AchievementToast invToast = new AchievementToast(Achievements.OPEN_INVENTORY, true);
         AchievementToast guideToast = new AchievementToast(Achievements.OPEN_GUIDEBOOK, true);
 
-        if (!this.mc.statsCounter.isUnlocked(Achievements.OPEN_INVENTORY) && !this.mc.guiToasts.isDisplayingToast(invToast))
-        {
+        if (!this.mc.statsCounter.isUnlocked(Achievements.OPEN_INVENTORY) && !this.mc.guiToasts.isDisplayingToast(invToast)) {
             this.mc.guiToasts.addToast(invToast);
         }
         if (/*this.mc.statsCounter.isUnlocked(Achievements.OPEN_INVENTORY) &&*/
-                !this.mc.statsCounter.isUnlocked(Achievements.OPEN_GUIDEBOOK) &&
+            !this.mc.statsCounter.isUnlocked(Achievements.OPEN_GUIDEBOOK) &&
 //                !this.mc.guiAchievementToast.isDisplayingToast(invToast) &&
                 !this.mc.guiToasts.isDisplayingToast(guideToast)
-        )
-        {
+        ) {
             this.mc.guiToasts.addToast(guideToast);
         }
 
         this.prevTimeInPortal = this.timeInPortal;
-        if(this.inPortal && !this.noPhysics)
-        {
-            if(!this.world.isClientSide && this.vehicle != null)
-            {
+        if (this.inPortal && !this.noPhysics) {
+            if (!this.world.isClientSide && this.vehicle != null) {
                 startRiding(null);
             }
-            if(this.mc.currentScreen instanceof ScreenContainerAbstract) // Close out of containers like the inventory
+            if (this.mc.currentScreen instanceof ScreenContainerAbstract) // Close out of containers like the inventory
             {
                 this.mc.displayScreen(null);
             }
-            if(this.timeInPortal == 0.0F)
-            {
+            if (this.timeInPortal == 0.0F) {
                 this.mc.sndManager.playSound("portal.trigger", SoundCategory.WORLD_SOUNDS, 1.0F, this.random.nextFloat() * 0.4F + 0.8F);
             }
             this.timeInPortal += 0.0125F;
-            if(this.timeInPortal >= 1.0F || getGamemode().instantPortalTravel())
-            {
+            if (this.timeInPortal >= 1.0F || getGamemode().instantPortalTravel()) {
                 this.timeInPortal = 1.0F;
-                if(!this.world.isClientSide)
-                {
+                if (!this.world.isClientSide) {
                     this.timeUntilPortal = 10;
                     this.mc.sndManager.playSound("portal.travel", SoundCategory.WORLD_SOUNDS, 1.0F, this.random.nextFloat() * 0.4F + 0.8F);
                     Dimension targetDim = ((BlockLogicPortal) Blocks.blocksList[this.portalID].getLogic()).targetDimension;
-                    if (this.dimension == targetDim.id)
-                    {
+                    if (this.dimension == targetDim.id) {
                         this.mc.usePortal(0, this.portalColor);
-                    }
-                    else
-                    {
+                    } else {
                         this.mc.usePortal(targetDim.id, this.portalColor);
                     }
                 }
             }
             this.inPortal = false;
-        } else
-        {
-            if(this.timeInPortal > 0.0F)
-            {
+        } else {
+            if (this.timeInPortal > 0.0F) {
                 this.timeInPortal -= 0.05F;
             }
-            if(this.timeInPortal < 0.0F)
-            {
+            if (this.timeInPortal < 0.0F) {
                 this.timeInPortal = 0.0F;
             }
         }
-        if(this.timeUntilPortal > 0)
-        {
+        if (this.timeUntilPortal > 0) {
             this.timeUntilPortal--;
         }
         float f = 0.8f;
@@ -202,83 +179,70 @@ public class PlayerLocal extends Player
 //        {
 //            ySlideOffset = 0.45F;
 //        }
-        checkInTile(this.x - (double) this.bbWidth * 0.35D, this.bb.minY + 0.5D, this.z + (double) this.bbWidth * 0.35D);
-        checkInTile(this.x - (double) this.bbWidth * 0.35D, this.bb.minY + 0.5D, this.z - (double) this.bbWidth * 0.35D);
-        checkInTile(this.x + (double) this.bbWidth * 0.35D, this.bb.minY + 0.5D, this.z - (double) this.bbWidth * 0.35D);
-        checkInTile(this.x + (double) this.bbWidth * 0.35D, this.bb.minY + 0.5D, this.z + (double) this.bbWidth * 0.35D);
+        checkAndPushInTile(this.x - (double) this.bbWidth * 0.35D, this.bb.minY + 0.5D, this.z + (double) this.bbWidth * 0.35D);
+        checkAndPushInTile(this.x - (double) this.bbWidth * 0.35D, this.bb.minY + 0.5D, this.z - (double) this.bbWidth * 0.35D);
+        checkAndPushInTile(this.x + (double) this.bbWidth * 0.35D, this.bb.minY + 0.5D, this.z - (double) this.bbWidth * 0.35D);
+        checkAndPushInTile(this.x + (double) this.bbWidth * 0.35D, this.bb.minY + 0.5D, this.z + (double) this.bbWidth * 0.35D);
         boolean canSprint = this.world.getGameRuleValue(GameRules.ALLOW_SPRINTING) && !this.noPhysics;
-        if (this.onGround && !forwardInput && this.input.moveForward >= f && !isSprinting() && canSprint)
-        {
-            if (this.sprintTimer == 0)
-            {
+        if (this.onGround && !forwardInput && this.input.moveForward >= f && !isSprinting() && canSprint) {
+            if (this.sprintTimer == 0) {
                 this.sprintTimer = 7;
-            }
-            else
-            {
+            } else {
                 setSprinting(true);
                 this.sprintTimer = 0;
             }
         }
-        if (this.onGround && canSprint && this.mc.gameSettings.keySprint.isPressed())
-        {
+        if (this.onGround && canSprint && this.mc.gameSettings.keySprint.isPressed()) {
             setSprinting(true);
         }
-        if (isSprinting() && (this.input.moveForward < f || this.horizontalCollision || !canSprint))
-        {
+        if (isSprinting() && (this.input.moveForward < f || this.horizontalCollision || !canSprint)) {
             setSprinting(false);
         }
         super.onLivingUpdate();
 
         WorldTypeFXDispatcher.getInstance().getDispatch(this.world.getWorldType()).playerAnimationTick(this.world, this);
     }
-    
+
     @Override
     public void wakeUpPlayer(boolean flag, boolean flag1) {
         super.wakeUpPlayer(flag, flag1);
         this.mc.displayScreen(null);
     }
-    
+
     @Override
-    public void addAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void addAdditionalSaveData(@NotNull CompoundTag tag) {
         super.addAdditionalSaveData(tag);
         tag.putInt("Score", this.score);
     }
 
     @Override
-    public void readAdditionalSaveData(@NotNull CompoundTag tag)
-    {
+    public void readAdditionalSaveData(@NotNull CompoundTag tag) {
         super.readAdditionalSaveData(tag);
         this.score = tag.getInteger("Score");
     }
 
     @Override
-    public void closeScreen()
-    {
+    public void closeScreen() {
         super.closeScreen();
         this.mc.displayScreen(null);
     }
 
     @Override
-    public void displaySignEditorScreen(TileEntitySign tileEntity)
-    {
+    public void displaySignEditorScreen(TileEntitySign tileEntity) {
         this.mc.displayScreen(new ScreenSignEditor(tileEntity));
     }
 
     @Override
-    public void displayFlagEditorScreen(TileEntityFlag tileEntity)
-    {
+    public void displayFlagEditorScreen(TileEntityFlag tileEntity) {
         this.mc.displayScreen(new ScreenFlagEditor(this, tileEntity));
     }
 
     @Override
-    public void displayContainerScreen(Container container)
-    {
+    public void displayContainerScreen(Container container) {
         this.mc.displayScreen(new ScreenContainer(this.inventory, container));
     }
 
-    public void displayChestScreen(Container container, double x, double y, double z)
-    {
+    public void displayChestScreen(Container container, double x, double y, double z) {
         displayContainerScreen(container);
     }
 
@@ -288,20 +252,17 @@ public class PlayerLocal extends Player
     }
 
     @Override
-    public void displayWorkbenchScreen(@NotNull TilePosc tilePos)
-    {
+    public void displayWorkbenchScreen(@NotNull TilePosc tilePos) {
         this.mc.displayScreen(new ScreenCrafting(this.inventory, this.world, tilePos));
     }
 
     @Override
-    public void displayLabelEditorScreen(ItemStack itemStack, int slot)
-    {
+    public void displayLabelEditorScreen(ItemStack itemStack, int slot) {
         this.mc.displayScreen(new ScreenLabelEditor(itemStack, slot));
     }
 
     @Override
-    public void displayPaintingPickerScreen()
-    {
+    public void displayPaintingPickerScreen() {
         this.mc.displayScreen(new ScreenPaintingPicker(this));
     }
 
@@ -310,6 +271,7 @@ public class PlayerLocal extends Player
         String currentMobId = ((TileEntityMobSpawner) this.world.getTileEntity(tilePos)).getMobId();
         this.mc.displayScreen(new ScreenMobPicker(currentMobId, tilePos));
     }
+
     @Override
     public void displayWandMobPickerScreen(ItemStack itemStack) {
         String currentMobId = itemStack.getData().getStringOrDefault("monster", "Pig");
@@ -317,8 +279,7 @@ public class PlayerLocal extends Player
     }
 
     @Override
-    public void displayFurnaceScreen(TileEntityFurnace tileEntity)
-    {
+    public void displayFurnaceScreen(TileEntityFurnace tileEntity) {
         this.mc.displayScreen(new ScreenFurnace(this.inventory, tileEntity));
     }
 
@@ -328,20 +289,17 @@ public class PlayerLocal extends Player
     }
 
     @Override
-    public void displayTrommelScreen(TileEntityTrommel tileEntity)
-    {
+    public void displayTrommelScreen(TileEntityTrommel tileEntity) {
         this.mc.displayScreen(new ScreenTrommel(this.inventory, tileEntity));
     }
 
     @Override
-    public void displayDispenserScreen(TileEntityDispenser tileEntity)
-    {
+    public void displayDispenserScreen(TileEntityDispenser tileEntity) {
         this.mc.displayScreen(new ScreenDispenser(this.inventory, tileEntity));
     }
 
     @Override
-    public void displayActivatorScreen(TileEntityActivator tileEntity)
-    {
+    public void displayActivatorScreen(TileEntityActivator tileEntity) {
         this.mc.displayScreen(new ScreenActivator(this.inventory, tileEntity));
     }
 
@@ -351,19 +309,17 @@ public class PlayerLocal extends Player
     }
 
     @Override
-    public void onItemPickup(Entity entity, ItemStack item)
-    {
+    public void onItemPickup(Entity entity, ItemStack item) {
         addStat(item.getItem().getStat(StatList.STAT_PICKED_UP), 1);
         this.mc.particleEngine.add(new ParticlePickupAnimation(this.mc.currentWorld, entity, this, -0.5F));
     }
 
-    public int getPlayerProtectionAmount()
-    {
+    public int getPlayerProtectionAmount() {
         return this.inventory.getTotalArmourPoints();
     }
 
     public void sendChatMessage(String s) {
-    	addToSendHistory(s);
+        addToSendHistory(s);
         if (s.startsWith("/")) {
             String command = s.substring(1);
             ClientCommandSource clientCommandSource = new ClientCommandSource(this.mc);
@@ -376,40 +332,35 @@ public class PlayerLocal extends Player
             this.mc.hudIngame.addChatMessage("<" + getDisplayName() + TextFormatting.RESET + "> " + TextFormatting.WHITE + s);
         }
     }
-    
+
     public void addToSendHistory(String msg) {
-    	if(msg == null || msg.isEmpty()) {
-    		return;
-    	}
-    	for(int i = 0; i < this.messageHistory.size(); i++) {
-    		if(this.messageHistory.get(i).equals(msg)) {
+        if (msg == null || msg.isEmpty()) {
+            return;
+        }
+        for (int i = 0; i < this.messageHistory.size(); i++) {
+            if (this.messageHistory.get(i).equals(msg)) {
                 this.messageHistory.remove(i--);
-    		}
-    	}
+            }
+        }
         this.messageHistory.add(msg);
-        if(this.messageHistory.size() > 100) {
+        if (this.messageHistory.size() > 100) {
             this.messageHistory.remove(0);
         }
     }
-    
+
     @Override
-    public boolean wantSneak()
-    {
+    public boolean wantSneak() {
         return (this.input != null && this.input.sneak) && !this.sleeping;
     }
 
-    public void setHealth(int i)
-    {
+    public void setHealth(int i) {
         int j = getHealth() - i;
-        if(j <= 0)
-        {
+        if (j <= 0) {
             setHealthRaw(i);
-            if(j < 0)
-            {
+            if (j < 0) {
                 this.heartsFlashTime = this.heartsHalvesLife / 2;
             }
-        } else
-        {
+        } else {
             this.lastDamage = j;
             this.prevHealth = getHealth();
             this.heartsFlashTime = this.heartsHalvesLife;
@@ -419,79 +370,66 @@ public class PlayerLocal extends Player
     }
 
     @Override
-    public void respawnPlayer()
-    {
+    public void respawnPlayer() {
         this.mc.respawn(false, 0);
     }
 
     @Override
-    public void animate4()
-    {
+    public void animate4() {
     }
-    
+
     @Override
-    public void addStat(Stat stat, int i)
-    {
-        if(stat == null) {
+    public void addStat(Stat stat, int i) {
+        if (stat == null) {
             return;
         }
-        if(stat.isAchievement()) {
-            Achievement achievement = (Achievement)stat;
-            if(achievement.parent == null || this.mc.statsCounter.isUnlocked(achievement.parent))
-            {
-                if(!this.mc.statsCounter.isUnlocked(achievement))
-                {
+        if (stat.isAchievement()) {
+            Achievement achievement = (Achievement) stat;
+            if (achievement.parent == null || this.mc.statsCounter.isUnlocked(achievement.parent)) {
+                if (!this.mc.statsCounter.isUnlocked(achievement)) {
                     this.mc.guiToasts.addToast(new AchievementToast(achievement, false));
                 }
                 this.mc.statsCounter.add(stat, i);
             }
-        } else
-        {
+        } else {
             this.mc.statsCounter.add(stat, i);
         }
     }
-    
+
     @Override
-    public int getStat(Stat stat)
-    {
+    public int getStat(Stat stat) {
         return this.mc.statsCounter.readStat(stat);
     }
 
     @Override
-    protected boolean checkInTile(double x, double y, double z)
-    {
+    protected boolean checkAndPushInTile(double x, double y, double z) {
         if (this.noPhysics) return false;
         final boolean isShort = this.isDwarf || this.isSneaking();
         final int blockX = MathHelper.floor(x);
         final int blockY = MathHelper.floor(y);
         final int blockZ = MathHelper.floor(z);
-        final double dX = x - (double)blockX;
-        final double dZ = z - (double)blockZ;
-        if(doesBlockPushOut(blockX, blockY, blockZ) || (doesBlockPushOut(blockX, blockY + 1, blockZ) && !isShort))
-        {
+        final double dX = x - (double) blockX;
+        final double dZ = z - (double) blockZ;
+        if (doesBlockPushOut(blockX, blockY, blockZ) || (doesBlockPushOut(blockX, blockY + 1, blockZ) && !isShort)) {
             final boolean flagWest = !doesBlockPushOut(blockX - 1, blockY, blockZ) && (isShort || !doesBlockPushOut(blockX - 1, blockY + 1, blockZ));
             final boolean flagEast = !doesBlockPushOut(blockX + 1, blockY, blockZ) && (isShort || !doesBlockPushOut(blockX + 1, blockY + 1, blockZ));
             final boolean flagNorth = !doesBlockPushOut(blockX, blockY, blockZ - 1) && (isShort || !doesBlockPushOut(blockX, blockY + 1, blockZ - 1));
             final boolean flagSouth = !doesBlockPushOut(blockX, blockY, blockZ + 1) && (isShort || !doesBlockPushOut(blockX, blockY + 1, blockZ + 1));
             Direction pushDirection = Direction.NONE;
             double minLength = Double.MAX_VALUE;
-            if(flagWest && dX < minLength)
-            {
+            if (flagWest && dX < minLength) {
                 minLength = dX;
                 pushDirection = Direction.WEST;
             }
-            if(flagEast && 1.0D - dX < minLength)
-            {
+            if (flagEast && 1.0D - dX < minLength) {
                 minLength = 1.0D - dX;
                 pushDirection = Direction.EAST;
             }
-            if(flagNorth && dZ < minLength)
-            {
+            if (flagNorth && dZ < minLength) {
                 minLength = dZ;
                 pushDirection = Direction.NORTH;
             }
-            if(flagSouth && 1.0D - dZ < minLength)
-            {
+            if (flagSouth && 1.0D - dZ < minLength) {
 //                minLength = 1.0D - dZ;
                 pushDirection = Direction.SOUTH;
             }
@@ -506,16 +444,16 @@ public class PlayerLocal extends Player
     public void syncPlacementMode() {
         this.placementModeOverride = this.mc.gameSettings.placementMode.value;
     }
-    
-	@Override
-	public void sendMessage(String message) {
+
+    @Override
+    public void sendMessage(String message) {
         this.mc.hudIngame.addChatMessage(message);
-	}
+    }
 
-	@Override
-	public void sendStatusMessage(String message) {
+    @Override
+    public void sendStatusMessage(String message) {
         this.mc.hudIngame.heldItemTooltipElement.setString(message);
-	}
+    }
 
     @Override
     public boolean lerpVehicleMotion() {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ButtonElement.java b/game/client/src/main/java/net/minecraft/client/gui/ButtonElement.java
index 4d18331c1..a5a4beb6e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ButtonElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ButtonElement.java
@@ -1,11 +1,11 @@
 package net.minecraft.client.gui;
 
+import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.window.CursorShape;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
-import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.core.util.helper.Listener;
@@ -37,21 +37,21 @@ public class ButtonElement extends Gui implements GuiElement
 
     public ButtonElement(int id, int xPosition, int yPosition, int width, int height, String text)
     {
-        enabled = true;
-        visible = true;
+        this.enabled = true;
+        this.visible = true;
         this.id = id;
         this.xPosition = xPosition;
         this.yPosition = yPosition;
         this.width = width;
         this.height = height;
-        displayString = text;
+        this.displayString = text;
         setDefaultTextures();
     }
 
     protected void setDefaultTextures() {
-        defaultTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button/button");
-        hoveredTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button/button_highlighted");
-        disabledTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button/button_disabled");
+        this.defaultTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button/button");
+        this.hoveredTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button/button_highlighted");
+        this.disabledTexture = TextureRegistry.getTexture("minecraft:gui/widgets/button/button_disabled");
     }
 
     public @NotNull ButtonElement setTextures(@Nullable String defaultTexture, @Nullable String hoveredTexture, @Nullable String disabledTexture) {
@@ -70,7 +70,7 @@ public class ButtonElement extends Gui implements GuiElement
     protected int getButtonState(boolean hovered)
     {
         int state = STATE_DEFAULT;
-        if(!enabled)
+        if(!this.enabled)
         {
             state = STATE_DISABLED;
         }
@@ -83,51 +83,36 @@ public class ButtonElement extends Gui implements GuiElement
 
     public void drawButton(Minecraft mc, int mouseX, int mouseY)
     {
-        if (!visible) return;
+        if (!this.visible) return;
 
-        boolean mouseOver = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
+        boolean mouseOver = mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width && mouseY < this.yPosition + this.height;
         int state = getButtonState(mouseOver);
 
-        if (mouseOver && visible && enabled) {
+        if (mouseOver && this.visible && this.enabled) {
             mc.currentScreen.setDesiredCursor(CursorShape.HAND);
         }
 
-        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        IconCoordinate tex;
-        switch (state) {
-            case STATE_DISABLED:
-                tex = disabledTexture;
-                break;
-            case STATE_HOVERED:
-                tex = hoveredTexture;
-                break;
-            case STATE_DEFAULT:
-            default:
-                tex = defaultTexture;
-        }
-        drawGuiIcon(xPosition, yPosition, width, height, tex);
+        GLRenderer.setColor4f(1f, 1f, 1f, 1f);
+        IconCoordinate tex = switch (state) {
+            case STATE_DISABLED -> this.disabledTexture;
+            case STATE_HOVERED -> this.hoveredTexture;
+            default -> this.defaultTexture;
+        };
+        drawGuiIcon(this.xPosition, this.yPosition, this.width, this.height, tex);
 
         mouseDragged(mc, mouseX, mouseY);
 
-        int textColor;
-        switch (state) {
-            case STATE_DISABLED:
-                textColor = 0xA0A0A0;
-                break;
-            case STATE_DEFAULT:
-                textColor = 0xE0E0E0;
-                break;
-            case STATE_HOVERED:
-            default:
-                textColor = 0xFFFFA0;
-                break;
-        }
-        drawStringCenteredShadow(mc.font, displayString, xPosition + width / 2, yPosition + (height - 8) / 2, textColor);
+        int textColor = switch (state) {
+            case STATE_DISABLED -> 0xA0A0A0;
+            case STATE_DEFAULT -> 0xE0E0E0;
+            default -> 0xFFFFA0;
+        };
+        drawStringCenteredShadow(mc.font, this.displayString, this.xPosition + this.width / 2, this.yPosition + (this.height - 8) / 2, textColor);
     }
 
     public boolean isHovered(int mouseX, int mouseY)
     {
-        return mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
+        return mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width && mouseY < this.yPosition + this.height;
     }
 
     public void mouseDragged(Minecraft mc, int mouseX, int mouseY)
@@ -140,7 +125,7 @@ public class ButtonElement extends Gui implements GuiElement
 
     public boolean mouseClicked(Minecraft mc, int mouseX, int mouseY)
     {
-        return enabled && mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
+        return this.enabled && mouseX >= this.xPosition && mouseY >= this.yPosition && mouseX < this.xPosition + this.width && mouseY < this.yPosition + this.height;
     }
     
     public ButtonElement setListener(Listener<ButtonElement> listener) {
@@ -180,22 +165,22 @@ public class ButtonElement extends Gui implements GuiElement
 
 	@Override
 	public int getX() {
-		return xPosition;
+		return this.xPosition;
 	}
 
 	@Override
 	public int getY() {
-		return yPosition;
+		return this.yPosition;
 	}
 
 	@Override
 	public int getWidth() {
-		return width;
+		return this.width;
 	}
 
 	@Override
 	public int getHeight() {
-		return height;
+		return this.height;
 	}
     
 }
